#include <stdio.h>
#include <string.h>
#include <stdlib.h>

const char BEGIN_MARK= 2;
const char MIDDLE_MARK= 3;
const char END_MARK= 4;

/************************** Mark v1.1 *************************************/               
/* Small ANSI compliant program to record data quickly and reference them */ 
/* with keywords. Useful for quickly storing URL addresses, ftp sites,    */
/* e-mail addresses, etc and being able to quickly output them back. Mark */
/* is FREEWARE although if you edit it please mention both my name and    */
/* program.                                                               */ 
/* 									  */
/* Installation Info: (g)cc mark.c -o mark               		  */
/*									  */
/* Contact Info: If wish to contact me my e-mail is aster1x@hotmail.com   */
/*               and I can also be reached via EFnet as AsteriX on #c.    */ 
/*								          */
/* Note: The data file ".mark" is stored in the users home directory.     */
/**************************************************************************/

FILE *FileOpen(char *szFileName, char *szMode);
void *malloc_check(size_t size);

int main(int argc , char *argv[])
{
 
 char *PATH;
 char *buff1;
 char *buff2;
 char buff3[256];
 char buff4[258];
 char *buff5;
 char *buff6;
 FILE *mark;
 long marksize;
 int argsize;
 int count, bleh;
 count=0;
 buff4[0]=MIDDLE_MARK;
 buff4[1]=0;
 
 
  if(argc==1)
    {
     puts("usage: mark [ -[[rd] ] [<keyword>] ] [-w <keyword> <description..> ]");
     exit(EXIT_FAILURE);
    }
              
  
  if( (buff1=getenv("HOME")) == NULL )
   {
    puts("ERROR: $HOME environment not found");
    exit(EXIT_FAILURE);
   }
  
  
 PATH=malloc_check(strlen(buff1)+10);
 strcpy(PATH,buff1);
 strcat(PATH, "/.mark");
 
 
	/* Deals with reading from mark file */
 
 if(!strcmp(argv[1], "-r") )
   {
     mark=FileOpen(PATH, "rb");
      if(mark==NULL)
       {
        puts("ERROR: no entries available");
        exit(EXIT_FAILURE);
       }
     
     fseek(mark , 0L, SEEK_END);
     marksize=ftell(mark);
     rewind(mark);
      if(marksize>500000)
       {
        puts("ERROR: mark file too large");
        fclose(mark);
        exit(EXIT_FAILURE);
       }
     
     buff1 = malloc_check( sizeof(char)*marksize+1 );
     fread(buff1, sizeof(char), (marksize+1), mark);
     fclose(mark);
      
      if( argc==2 )            
       {
        buff2=buff1;
       
        while(1)
         {
    
          count=0;
         
          if( ( buff2=strchr(buff2 , BEGIN_MARK) ) !=NULL )
           { 
          
            while( *(buff2+count+1)!=buff4[0] )
             {
              putchar( *(buff2+count+1) );
              count++;
             }
          
            *buff2=*(buff2+1);
            printf(":  ");
         
           }
         
             else 
              {
               printf("\n");
               break;
          
              }
         }
     
   }
  
   else if(argc==3)
    {
     if(strlen(argv[2]) > 255 )
       exit(EXIT_FAILURE);
     
     strcpy(buff3 , argv[2]);
     buff5=strcat(buff3 , buff4 );
     buff4[0]=BEGIN_MARK;
     buff6=strcat(buff4 , buff5);
      
      if( ( buff2=strstr(buff1 , buff6) ) == NULL )
       {
        puts("ERROR : String not found.");
        exit(EXIT_FAILURE);
       } 
    
     memset(buff3 , 0 , strlen(buff3) ); 
     count=0;
     buff4[0]=END_MARK;
   
     /* Finds the number of characters the "detail" is. */
     
      while(  *(buff2 + strlen(argv[2]) + count +2  )  !=buff4[0] )
       {
     
        buff3[count]=*(buff2+strlen(argv[2])+count+2);
        count++;
     
       }
    
     bleh=0;
     count=atoi(buff3);
     printf("%s: " , argv[2]);
     
      for(bleh=0; bleh<count; bleh++)
       {
      putchar( *(buff2+strlen(argv[2])+strlen(buff3)+bleh+3 ) );
 
       }
     printf("\n");
 
    }
      
    else
     {
      puts("ERROR: invalid argument");
      puts("usage: mark -r [<keyword>]"); 
       exit(EXIT_FAILURE);
     }
   }
 
	/* Deals with writing mark to mark file */
 
 else if(!strcmp(argv[1], "-w") )
  {
   if(argc==4)
    {
     mark=FileOpen(PATH, "a+b"); 
     fseek(mark, 0L, SEEK_END);
     marksize=ftell(mark);
     rewind(mark);
      
      if(marksize>500000)
       {
        puts("ERROR: mark file too large");
        fclose(mark);
        exit(EXIT_FAILURE);
       }
                                                 
     buff1=malloc_check( marksize * sizeof(char)+1);
     fread( buff1 , sizeof(char), (marksize+1), mark ) ;
                                                                                               
     count=strlen(argv[2]);
     argsize=strlen(argv[3]);
     
      if(count>255)
       {
        puts("ERROR: Keyword length too long.");
        fclose(mark);
        exit(EXIT_FAILURE);
       }
      
      strcpy(buff3 , argv[2]);
      buff4[0]=BEGIN_MARK;
      buff4[1]=0;
      strcat(buff4,buff3 );
      buff3[0]=MIDDLE_MARK;
      buff3[1]=0;
      strcat(buff4, buff3);
       
       if( (strstr(buff1, buff4)) != NULL )
        {
         puts("ERROR: keyword already exists");
         fclose(mark);
         exit(EXIT_FAILURE);
        }           

     fprintf(mark , "%c%s%c%d%c%s" ,BEGIN_MARK,argv[2],MIDDLE_MARK, argsize , END_MARK, argv[3] );
     fclose(mark);
    }
     else 
      {
       printf("ERROR: invalid argument\n");    
       puts("usage: mark -w <keyword> <description...>");
       exit(EXIT_FAILURE);
      }

  }


	/* If persons desires help */
   
   else if(!strcmp(argv[1], "-h") ) 
    {
	puts("usage: mark [ -[[rd] ] [<keyword>] ] [-w <keyword> <description..> ]");
	puts("mark -w <keyword> <description> writes description referenced by keyword.");
	puts("mark -r lists all keywords.");
	puts("mark -r <keyword> outputs description referenced by keyword.");
        puts("mark -d <keyword> deletes description referenced by keyword.");
	exit(EXIT_SUCCESS);
    }
      /* For deletion of keyword */
     else if(!strcmp(argv[1], "-d") )
           {
              if( argc==3 )    
                {  
                  mark=FileOpen(PATH, "a+b");
                  
                  fseek(mark, 0L, SEEK_END);
                  marksize=ftell(mark);
                  rewind(mark);
                   if(marksize>500000)
                    {
                     puts("ERROR: mark file too large");
                     fclose(mark);
                     exit(EXIT_FAILURE);
                    }                                                                                      
                  
                  buff1=malloc_check( marksize * sizeof(char)+1);
                  fread( buff1 ,sizeof(char), (marksize+1), mark ) ;
                  fclose(mark);
                  remove(PATH);
                  mark=FileOpen(PATH, "a+b");
                  
                  if(strlen(argv[2]) > 255)
                   {
                    puts("ERROR: keyword length too long");
                    exit(EXIT_FAILURE);
                   }
                  
                  strcpy(buff3, argv[2]);
                  buff4[0]=BEGIN_MARK;
                  strcat(buff4, buff3);
                  buff3[0]=MIDDLE_MARK;
                  buff3[1]=0;
                  strcat(buff4, buff3);
                                    
                  if( (buff2=strstr(buff1 , buff4)) == NULL )
                   {
                    puts("ERROR: keyword not found");
                    fclose(mark);
                    exit(EXIT_FAILURE);
                   }
                  
                  count=((int)buff2-(int)buff1)+1;
		  
		  buff4[0]=BEGIN_MARK; 
		  buff4[1]=0;
		  
		  buff5=malloc_check( count * sizeof( char ) ); 
                  count--;
                  strncpy(buff5, buff1, count);                   
                   
                   if ( ( buff2=strchr((buff2+1), buff4[0]) )== NULL) {
                     fprintf(mark,"%s" , buff5);
                    }
                     else
                      {
                       fprintf(mark , "%s%s" , buff5 , (  buff2));   
                      }
                  fclose(mark);
                }  
                 else
                  {
                   puts("ERROR: invalid argument");
                   puts("usage: mark -d [<keyword>]");
                   exit(EXIT_FAILURE);
                  }  
            }
                                      
	else
	 {
	  puts("ERROR: invalid argument");
	  puts("usage: mark [ -[[rd] ] [<keyword>] ] [-w <keyword> <description..> ]");
	  exit(EXIT_FAILURE);
	 }

return EXIT_SUCCESS;

}

 FILE *FileOpen(char *szFileName, char *szMode) 
{
   FILE *fp; 
   fp = fopen(szFileName, szMode); 
     
     if (!fp) 
      { 
       puts("ERROR: open file failed"); 
       exit(EXIT_FAILURE); 
      } 
       
   return fp; 
}
 
 void *malloc_check(size_t size)
{
 void *ptr;
 
 if( (ptr=malloc(size) ) == NULL)
  {
   puts("ERROR: malloc failure");
   exit(EXIT_FAILURE);
  }

 return ptr;
} 
                            
